//        
#define F_CPU 16000000UL  //  16 MHz

#include "nokia3310.h"
#include "hardware.h"
#include "ksh148.h"
#include "LC72131.h"
#include "encoder.h"
#include "eeprom.h"

#define ADC_BAT_NI_MH_75 800
#define ADC_BAT_NI_MH_50 700
#define ADC_BAT_NI_MH_25 560

#define ADC_BAT_AAx3_75  920
#define ADC_BAT_AAx3_50  720
#define ADC_BAT_AAx3_25  580

#define ADC_BAT_LION_75  760
#define ADC_BAT_LION_50  720
#define ADC_BAT_LION_25  680

#define RCV_MAX          855000
#define RCV_MIN          40000
#define SLEEP_MAX        20
#define SLEEP_MIN        3

unsigned char spectr_count = 0;
unsigned char step_spertr=59;
unsigned char k=0;
unsigned char marker_f=40;
unsigned char f_clear = FALSE;
unsigned char f_change = FALSE;

volatile uint8_t  dataLC[4];
unsigned char pwm = 0;

unsigned char Resiver_mode  = WFM_STEREO;      // 
unsigned char Stereo_in     = WFM_STEREO_IN;   //   
unsigned char Signal_IN     = WFM_IN;          //     fm  nfm   
volatile int  sleep_count   = 0;
volatile char sleep_countS  = 0;
volatile char f_sleep       = FALSE;
volatile unsigned int  adc_bat;  
volatile uint32_t  adc_bat_sum;
unsigned char adc_count = 0;
volatile char f_adc = 0;
uint32_t V_BAT = 0;                            //   
//0 
// 
volatile char f_press_butM  = FALSE;           //   
volatile char f_butM        = FALSE;           //   
volatile char f_butM_3c     = FALSE;           //       3 
volatile int  press_countM  = 0;  
// 
volatile char f_press_butS  = FALSE;           //   
volatile char f_butS        = FALSE;           //   
volatile char f_butS_3c     = FALSE;           //       3 
volatile int  press_countS  = 0;
// 
volatile  unsigned char Radio_Mode    = RADIO; //       
// /
unsigned char menu_radio    = SAVE;            //   /
uint16_t Mem_R_cell         = N_MEM_RADIO_MIN; //      
uint16_t Mem_W_cell         = N_MEM_RADIO_MIN; //      
unsigned char f_Memwrite    = FALSE; 
unsigned char f_SCAN        = FALSE; 
unsigned char f_SCAN_fist   = TRUE; 
//
unsigned char Bat_pow       = Bat_100;         // 
int           Bat_pow_int   = 0;  
// 
unsigned char menu_option   = APU;             //   
unsigned char APU_int       = 255;             //   
unsigned char N_View        = LI_ION;          // 
unsigned char ARU_int       = 255;             // 
volatile unsigned char Sleep_int     = 10;     //     

volatile int state_count    = 0;               //  
volatile char f_state       = FALSE;           //     
  
//------------------------------------------------------------------------------//
//-----------------------------   ----------------//
//------------------------------------------------------------------------------//
//---------  -----------
void DiplayBatState(void)
{
  //char *Bat_pow_int_str;
  unsigned char *Bat_state = (unsigned char *)Battery0;
  //      
  switch(Bat_pow)
  {
     case Bat_75:
	      Bat_state = (unsigned char *)Battery100;   break;
	 case Bat_50:
          Bat_state = (unsigned char *)Battery50;    break;
	 case Bat_25:
          Bat_state = (unsigned char *)Battery25;    break;
	 case Bat_0:
          Bat_state = (unsigned char *)Battery0;    break;	
  }
  LCD_PutPicture(Bat_state, 73, 0, 10);  
  //Bat_pow_int_str = itoa2(Bat_pow_int); 
  //lcd_PutStr(Bat_pow_int_str,18,70); 
}



//---------    
void DiplayFreq_Normal(void)
{
  char *FrcvWork_str;  
  char *FrcvStep_str = "1";  
  
  nokia_cls();
  //Clear_SrcFull(0, 30, 100, 40, 0b00000011);
  DiplayBatState(); 

  FrcvWork_str = itoa2(FrcvWork);   	
  if(FrcvWork >= 100000)
     LCD_PutStr16x12(FrcvWork_str, 1, 2, 0 );	
  else
  {   
     LCD_PutChar16x12(0x3A, 1, 2, 0);
     LCD_PutStr16x12(FrcvWork_str, 13, 2, 0);
  }	
 // LCD_PutChar16x12('3', 10, 2, 0);
 // LCD_PutStr("",50,2, 0);  
  
  LCD_PutStr("      ",1,0,0);           //     
  switch(FindStep)
  {
     case 0:
	    FrcvStep_str = "1"; break;
	 case 1:
	    FrcvStep_str = "5"; break;
     case 2:
	    FrcvStep_str = "10"; break;	
	 case 3:
	    FrcvStep_str = "15"; break;	 
     case 4:
	    FrcvStep_str = "20"; break;	 	
	 case 5:
	    FrcvStep_str = "25"; break;	 
     case 6:
	    FrcvStep_str = "50"; break;	 
     case 7:
	    FrcvStep_str = "100"; break;	
     case 8:
	    FrcvStep_str = "500"; break;	
     case 9:
	    FrcvStep_str = "1"; break;
  	 case 10:
	    FrcvStep_str = "5"; break; 
     case 11:
	    FrcvStep_str = "10"; break; 	
  }
  LCD_PutStr("      ",1,0, 0);
  LCD_PutStr(FrcvStep_str,1,0, 0);   
  
  if(Stereo_in == WFM_STEREO_IN)
     LCD_PutStr("s",35,0, 0);
  
  if(Resiver_mode == WFM_STEREO)
     LCD_PutStr("WFM S",43,0, 0);
  if(Resiver_mode == WFM_MONO)
     LCD_PutStr("WFM M",43,0, 0);	
  if(Resiver_mode == NFM)
     LCD_PutStr("NFM",43,0, 0);  
  
  LCD_PutRadioLine(0, 5);
  LCD_PutRadioFreqLine(FrcvWork, RCV_MAX, RCV_MIN, 0);	  
}

void DiplayFreq_Change(void)
{ 
  char *FrcvWork_str; 
  static uint32_t FrcvWork_Pre;
   
  FrcvWork_str = itoa2(FrcvWork);  
 	
  if(FrcvWork >= 100000)
     LCD_PutStr16x12(FrcvWork_str, 1, 2, 0 );	
  else
  {   
     LCD_PutChar16x12(0x3A, 1, 2, 0);
     LCD_PutStr16x12(FrcvWork_str, 13, 2, 0);
  }	
   	
  LCD_PutRadioLine(0, 5);
  LCD_PutRadioFreqLine(FrcvWork_Pre, RCV_MAX, RCV_MIN, 1);
  LCD_PutRadioFreqLine(FrcvWork, RCV_MAX, RCV_MIN, 0);	
  FrcvWork_Pre = FrcvWork;	
}



void DiplayLoadMemoryRadio(int8_t f_no_error)
{
    char *FrcvWork_str;	
	
    if(f_no_error == 1)
    {
       FrcvWork_str = itoa2(FrcvWorkMEM);
       if(FrcvWork >= 100000)
          LCD_PutStr(FrcvWork_str, 10, 4, 0);
       else
       {   
          LCD_PutStr((char *)0x3A, 10, 4, 0);
          LCD_PutStr(FrcvWork_str, 15, 4, 0);
       } 
       if(Resiver_modeMEM == WFM_STEREO)
          LCD_PutStr("WFM S",50,4, 0);
       if(Resiver_modeMEM == WFM_MONO)
          LCD_PutStr("WFM M",50,4, 0);	
       if(Resiver_modeMEM == NFM)
          LCD_PutStr("NFM  ",50,4, 0);  
    }
    else
        LCD_PutStr("......", 10, 4, 0);   		
}

//---------     
void DiplayMemoryRadio(void)
{
   char *FrcvWork_str;
   char *n_cell_str;
   uint16_t n_cell;
   char num_menu = 12;
   static int8_t f_no_error;
         
		 
   nokia_cls();
   DiplayBatState(); 
 
   LCD_PutStr("",0,0,0);  

   if(menu_radio == SAVE)     num_menu = 1;
   if(menu_radio == LOAD)     num_menu = 3;
   if(menu_radio == EXIT)     num_menu = 5;
   
   LCD_PutSimol(1, 0, num_menu); // 

   //----------     
   LCD_PutStr(" .",7,1, 0);
   n_cell = (Mem_W_cell - 20)>>2;   
   
   n_cell_str = itoa2(n_cell); 
   LCD_PutStr(n_cell_str,70,1, 0);
     
   if(f_Memwrite == TRUE) 
      LCD_PutStr("C.",60,5, 0);  
   
   FrcvWork_str = itoa2(FrcvWork); 
   if(FrcvWork >= 100000)
     LCD_PutStr(FrcvWork_str, 10, 2, 0);
   else
   {   
     LCD_PutStr((char *)0x3A, 10, 2, 0);
     LCD_PutStr(FrcvWork_str, 15, 2, 0);
   }  
      
   //LCD_PutStr("",47, 2, 0);
   if(Resiver_mode == WFM_STEREO)
      LCD_PutStr("WFM S",50,2, 0);
   if(Resiver_mode == WFM_MONO)
      LCD_PutStr("WFM M",50,2, 0);	
   if(Resiver_mode == NFM)
      LCD_PutStr("NFM  ",50,2, 0);  
     
   //----------    
   LCD_PutStr(" .",7,3, 0); 
   n_cell = (Mem_R_cell - 20)>>2;   
   
   n_cell_str = itoa2(n_cell); 
   LCD_PutStr(n_cell_str,70,3, 0);  
   
   if(menu_radio == LOAD)
   {
      if((IndMEM != Mem_R_cell) || f_Memwrite == TRUE)
      { 
         IndMEM = Mem_R_cell; 
         f_no_error = rMEM_Freq(); 
      }
      DiplayLoadMemoryRadio(f_no_error);
           
      //LCD_PutStr("",47, 4, 0b00000011, 0b11111100);
	  f_Memwrite = FALSE;
   }
      
   LCD_PutStr("",7,5, 0);       
}

void DiplayMemoryRadio_ChangePosition(void)
{
   char num_menu = 1;
   char num_menu_pred = 1;
   
   if(menu_radio == SAVE)  {  num_menu = 1; num_menu_pred = 5;  }
   if(menu_radio == LOAD)  {  num_menu = 3; num_menu_pred = 1;  }
   if(menu_radio == EXIT)  {  num_menu = 5; num_menu_pred = 3;  }
   
   
   LCD_PutStr(" ",0,num_menu_pred, 0);
   LCD_PutSimol(1,  0, num_menu);   //     
}


void DiplayMemoryRadio_W_cellChange(void)
{
   uint16_t n_cell;
   char *n_cell_str;
   
   LCD_PutStr("   ",70,1, 0);
   n_cell = (Mem_W_cell - 20)>>2;   
   n_cell_str = itoa2(n_cell); 
   LCD_PutStr(n_cell_str,70,1, 0);
}


//---------    
void DiplayMENURadio(void)
{
   char num_menu = 12;
   char *Param_str = "";

   nokia_cls();
   DiplayBatState();  
	 
   LCD_PutStr("",0,0, 0);  

   if(menu_option == APU)       num_menu = 1;
   if(menu_option == View)      num_menu = 2;
   if(menu_option == ARU)       num_menu = 3;
   if(menu_option == SLEEP)     num_menu = 4;
   if(menu_option == BRUST  ||  
      menu_option == QUARZ  ||  
      menu_option == SAVE_O ||  
      menu_option == EXIT_O)    num_menu = 5;
   
   LCD_PutSimol(1, 0, num_menu); // 
   
   if(menu_option != SAVE_O && menu_option != EXIT_O && menu_option != QUARZ)
   {
      Param_str = itoa2(APU_int); 
      LCD_PutStr(Param_str,54,1, 0);
      LCD_PutStr("SQL .=" ,7,1, 0);  
      LCD_PutStr("     =",7, 2, 0); 
      if(N_View == NI_MH)
         LCD_PutStr("NI-MH" ,54,2, 0); 
      if(N_View == AAx3)
         LCD_PutStr("AAx3",54,2, 0);
      if(N_View == LI_ION)
         LCD_PutStr("LI-ION",54,2, 0);
      Param_str = itoa2(ARU_int);  
      LCD_PutStr(Param_str,54,3, 0); 
      LCD_PutStr("     ="       ,7,3, 0);
      Param_str = itoa2(Sleep_int); 
      LCD_PutStr(Param_str,54,4, 0); 
      LCD_PutStr("()=" ,7,4, 0);
	  LCD_PutStr(".. =",7,5, 0);
	  if(BRUST_int == On)
	     LCD_PutStr("",54,5, 0); 
	  else
         LCD_PutStr("",54,5, 0);   	 
   } 
   if(menu_option == QUARZ)
   {
      LCD_PutStr("     =",7, 1, 0); 
      if(N_View == NI_MH)
         LCD_PutStr("NI-MH" ,54,1, 0); 
      if(N_View == AAx3)
         LCD_PutStr("AAx3",54,1, 0);
      if(N_View == LI_ION)
         LCD_PutStr("LI-ION",54,1, 0);
      Param_str = itoa2(ARU_int);  
      LCD_PutStr(Param_str,54,2, 0); 
      LCD_PutStr("     ="       ,7,2, 0);
      Param_str = itoa2(Sleep_int); 
      LCD_PutStr(Param_str,54,3, 0); 
      LCD_PutStr("()=" ,7,3, 0);
	  LCD_PutStr(".. =",7,4, 0);
	  if(BRUST_int == On)
	     LCD_PutStr("",54,4, 0); 
	  else
         LCD_PutStr("",54,4, 0);   	 
	  LCD_PutStr("   =" ,7,5, 0);   	
	  if(Quarz_int == Q_7_2MHz)
	     LCD_PutStr("7.2",54,5, 0);
	  else
         LCD_PutStr("4.5",54,5, 0); 
   }  
   
   if(menu_option == SAVE_O)
   {
      Param_str = itoa2(ARU_int);  
      LCD_PutStr(Param_str,54,1, 0); 
      LCD_PutStr("     ="       ,7,1, 0);
      Param_str = itoa2(Sleep_int); 
      LCD_PutStr(Param_str,54,2, 0); 
      LCD_PutStr("()=" ,7,2, 0);
	  LCD_PutStr(".. =",7,3, 0);
	  if(BRUST_int == On)
	     LCD_PutStr("",54,3, 0); 
	  else
         LCD_PutStr("",54,3, 0);   	 
	  LCD_PutStr("   =" ,7,4, 0);   	
	  if(Quarz_int == Q_7_2MHz)
	     LCD_PutStr("7.2",54,4, 0);
	  else
         LCD_PutStr("4.5",54,4, 0);   
	  LCD_PutStr("" ,7,5, 0);
      if(f_Memwrite == TRUE) 
      {
         f_Memwrite = FALSE;
	     LCD_PutStr("." ,62,5, 0);
      }	 
   }
   if(menu_option == EXIT_O)
   {      
      LCD_PutStr(Param_str,54,1, 0); 
      LCD_PutStr("()=" ,7,1, 0);
	  LCD_PutStr(".. =",7,2, 0);
	  if(BRUST_int == On)
	     LCD_PutStr("",54,2, 0); 
	  else
         LCD_PutStr("",54,2, 0);   	 
	  LCD_PutStr("   =" ,7,3, 0);   	
	  if(Quarz_int == Q_7_2MHz)
	     LCD_PutStr("7.2",54,3, 0);
	  else
         LCD_PutStr("4.5",54,3, 0);   
	  LCD_PutStr("" ,7,4, 0);
      if(f_Memwrite == TRUE) 
      {
         f_Memwrite = FALSE;
	     LCD_PutStr("." ,62,4, 0);
      }	 
      LCD_PutStr("" ,7,5, 0);  
   }
  
     	
}

void DiplayMENURadio_APUChange(void)
{   
   char *Param_str; 
    
   LCD_PutStr("   ",54,1, 0);
   Param_str = itoa2(APU_int); 
   LCD_PutStr(Param_str,54,1, 0); 
} 

void DiplayMENURadio_ViewChange(void)
{
   if(N_View == NI_MH)
      LCD_PutStr("NI-MH ",54,2, 0); 
   if(N_View == AAx3)
      LCD_PutStr("AAx3  ",54,2, 0);
   if(N_View == LI_ION)
      LCD_PutStr("LI-ION",54,2, 0);
}

void DiplayMENURadio_ARUChange(void)
{
   char *Param_str;

   LCD_PutStr("   ",54,3, 0);
   Param_str = itoa2(ARU_int);  
   LCD_PutStr(Param_str,54,3, 0); 
}
void DiplayMENURadio_SleepChange(void)
{
   char *Param_str;  
   
   LCD_PutStr("  ",54,4, 0);
   Param_str = itoa2(Sleep_int); 
   LCD_PutStr(Param_str,54,4, 0);   
}

void DiplayMENURadio_BRUSTChange(void)
{
   LCD_PutStr("    ",54,5, 0);   
   if(BRUST_int == On)
      LCD_PutStr("",54,5, 0);   
   else
      LCD_PutStr("",54,5, 0); 	  
}

void DiplayMENURadio_QuarzChange(void)
{
   LCD_PutStr("      ",54,5, 0);
   if(Quarz_int == Q_7_2MHz)
      LCD_PutStr("7.2",54,5, 0);  
   else
      LCD_PutStr("4.5",54,5, 0); 
}




//
ISR(ADC_vect)
{
   adc_bat  = ADC;
   if(adc_count < 100)   
   {   
      adc_bat_sum = adc_bat_sum + adc_bat;
	  adc_count++;
   }
   else
   {
      adc_bat = (unsigned int)(adc_bat_sum/100);
	  adc_bat_sum = 0;
	  adc_count = 0;
	  f_adc = 1; 
   }    
}
//--------------------------------------------//
//----------0  
//--------------------------------------------//
ISR(TIMER0_OVF_vect)
{
   TCNT0 = 0x64; //reload counter value
   
   if(f_butS == FALSE)
   {
   
      if(f_press_butS == FALSE)
      {  
         if(GetState(BUT_IN, BUT_S_Bit) == 0)//GetBit(BUT_IN, BUT_S_Bit)== 0)  
	     {    
	         if(press_countS != 200)
		        press_countS++;
		     else
                f_press_butS = TRUE;	
	     }
         else
         {    
            if(press_countS > 10)
               f_butS = TRUE; 
            press_countS = 0;
         }
      }
      else
      {
         if(press_countS == 200)                    
            f_butS_3c = TRUE;         
         else         
            f_butS_3c = FALSE;
         press_countS = 0;
         f_press_butS = FALSE;
         f_butS = TRUE; 	  	 	      
      }
   } 
   if(f_butM == FALSE)
   {   
      if(f_press_butM == FALSE)
      {  
         if(GetState(BUT_IN, BUT_M_Bit) == 0)//GetBit(BUT_IN, BUT_S_Bit)== 0)  
	     {    
	         if(press_countM != 200)
		        press_countM++;
		     else
                f_press_butM = TRUE;	
	     }
         else
         {    
            if(press_countM > 10)
               f_butM = TRUE;
            press_countM = 0;                                   
         }
      }
      else
      {
         if(press_countM == 200)                    
            f_butM_3c = TRUE;         
         else         
            f_butM_3c = FALSE;
         press_countM = 0;
         f_press_butM = FALSE;
         f_butM = TRUE; 	  	 	      
      }
   } 
   if(f_sleep == FALSE)
   {
      sleep_count++;
      sleep_countS = (unsigned char)(sleep_count/100);
      if(Sleep_int <= sleep_countS)
      {
         sleep_count = 0;
		 f_sleep = TRUE;
      } 
   }          
}
//--------------------------------------------//
//        
void Set_Regim(void)
{
    switch(Resiver_mode)
	{
	   case WFM_STEREO:   
	        Resiver_mode = WFM_MONO;   
			Stereo_Mono  = WFM_MONO;   
			SetBit(NFMWFM_Port,NFMWFM_Bit);  // FM
			Lc72131Set();
			break;
	   case WFM_MONO:     
	        Resiver_mode = NFM;        
			ClrBit(NFMWFM_Port,NFMWFM_Bit);
			break;
	   case NFM:          
	        Resiver_mode = WFM_STEREO; 
			Stereo_Mono  = WFM_STEREO;  
			SetBit(NFMWFM_Port,NFMWFM_Bit);
			Lc72131Set();
			break;
	}
	 
}

void ReadBatState(void)
{    
        
    //adc_init(ADC_BAT_CH); 
    //_delay_us(10);
	cli();
	if(f_adc == 1)
	{
	   f_adc = 0; 
	   Bat_pow_int = adc_bat; 
    }     
    sei();
   
    if( Bat_pow_int > 0)
	{
       switch(N_View)
	   {
	     case NI_MH:
	        if(Bat_pow_int >= ADC_BAT_NI_MH_75 )                                    Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_NI_MH_50 && Bat_pow_int  < ADC_BAT_NI_MH_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_NI_MH_25  && Bat_pow_int  < ADC_BAT_NI_MH_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_NI_MH_25)                                       Bat_pow = Bat_0;   
		    break;
	      case AAx3:
	        if(Bat_pow_int >= ADC_BAT_AAx3_75 )                                    Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_AAx3_50 && Bat_pow_int  < ADC_BAT_AAx3_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_AAx3_25  && Bat_pow_int  < ADC_BAT_AAx3_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_AAx3_25)                                       Bat_pow = Bat_0;   
		    break;
	      case LI_ION:
	        if(Bat_pow_int >= ADC_BAT_LION_75 )                                   Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_LION_50 && Bat_pow_int  < ADC_BAT_LION_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_LION_25  && Bat_pow_int  < ADC_BAT_LION_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_LION_25)                                      Bat_pow = Bat_0;   
		    break;
	   }        
    }  
}

void ReadLC72131State(void)
{  
    //char *IO_str;
	//int adc_fm=0;
	//uint32_t adc_tek;

    Lc72131Get();
    Stereo_in = StereoMono_In;
    if(Stereo_in == WFM_STEREO_IN)
       LCD_PutStr("s",35,0, 0);  	  
    else
       LCD_PutStr(" ",35,0, 0);    
    //Lc72131GetFreq();
	/*LC72131GetFreq();
	IO_str = itoa2(FrcvSQL);
	lcd_PutStrFill(IO_str,45,50, 0b00000011, 0b11111111); */
	_delay_ms(1);
}

//----------------------------- ----------------------------//
ISR(TIMER2_OVF_vect)
{
   TCNT2 = 0x83; //reload counter value
   EncPoll();   
   state_count++;
   if(state_count == 250) // 
   {
     state_count = 0;
	 f_state     = TRUE;
   }
   
}
//------------------------------------------------------------------------//

void LoadOptionFromEEPROM(void)
{
   if(rMEM_Options())
   {
      APU_int         = APU_intMEM;
      N_View          = N_ViewMEM;
	  ARU_int         = ARU_intMEM;
	  Sleep_int       = Sleep_intMEM;
	  FindStep        = FindStepMEM;
      FrcvWork        = FrcvWorkMEM;
      Resiver_mode    = Resiver_modeMEM;
      BRUST_int       = BRUST_intMEM;
      Quarz_int       = Quarz_intMEM;	  
   }
} 


int main(void) 
{  
  unsigned char n;

  init_devices();
		
  InitLCD(); 		
  nokia_cls();
	
  FrcvWork   = 105200; 
  LoadOptionFromEEPROM();
  DiplayFreq_Normal();
  
  ON_Light();  
  UapuB_Out(APU_int); 
  UapyA_Out(ARU_int);    
  Lc72131Set(); 
  KSH14xPLL2();   	
  
  while(1)
  {
     //----------------------  
	 if(Param != 0)
	 {
        switch(Radio_Mode) 
        {  
		    //---------------  
            case RADIO:                  
	           cli();
			   n = Param;
			   Param = 0;
			   sei();
			   if(n == RIGHT_SPIN) //  
               {
			      if(FrcvWork < (RCV_MAX - Step[FindStep]))
                     FrcvWork = FrcvWork + Step[FindStep]; 					 	
				   
               }    
               if(n == LEFT_SPIN)  //  
               {
			      if(FrcvWork > (RCV_MIN + Step[FindStep]))
                     FrcvWork = FrcvWork - Step[FindStep]; 
				 
               }
			   //Param = 0;
		       Lc72131Set(); //       
               KSH14xPLL2(); //   	
			   DiplayFreq_Change();            
               break;
		   //----------    
           case MENU: 
               switch(menu_option)  
               {
			     case APU:   //   -  
				    if(Param == RIGHT_SPIN) APU_int++;
					if(Param == LEFT_SPIN)  APU_int--;
                    UapuB_Out(APU_int); 
                    DiplayMENURadio_APUChange();				    
					break;
			     case View:   //
                    if(Param == RIGHT_SPIN) 
					{
					   switch(N_View)
					   {
					      case NI_MH:     N_View = AAx3;       break;
						  case AAx3:      N_View = LI_ION;     break;
						  case LI_ION:    N_View = NI_MH;      break;
					   }					   
					   
					}
					if(Param == LEFT_SPIN)  
					{  
					   switch(N_View)
					   {
					      case NI_MH:     N_View = LI_ION;     break;
						  case LI_ION:    N_View = AAx3;       break;
						  case AAx3:      N_View = NI_MH;      break;
					   }
					}
					DiplayMENURadio_ViewChange();
					break;
                 case ARU:   //   
                    if(Param == RIGHT_SPIN) ARU_int++;
					if(Param == LEFT_SPIN)  ARU_int--;
					UapyA_Out(ARU_int);
					DiplayMENURadio_ARUChange();
					break;
                 case SLEEP: //        
                    if(Param == RIGHT_SPIN) if(Sleep_int < SLEEP_MAX) Sleep_int++;
					if(Param == LEFT_SPIN)  if(Sleep_int > SLEEP_MIN) Sleep_int--;
					DiplayMENURadio_SleepChange();
					break;  
	             case BRUST: 
				    if(BRUST_int == On) BRUST_int = Off;
					else                 BRUST_int = On;
					DiplayMENURadio_BRUSTChange();
					break;
				 case QUARZ: 
				    if(Quarz_int == Q_7_2MHz) Quarz_int = Q_4_5MHz;
					else                       Quarz_int = Q_7_2MHz;
					DiplayMENURadio_QuarzChange();
					break;  	
			   } 	
               //f_change = TRUE;              
               break; 	
           //----------       
           case MENU_MEMORY:
               switch(menu_radio)
               {
                 case SAVE: //     
                    if(Param == RIGHT_SPIN) if(Mem_W_cell < N_MEM_RADIO_MAX) Mem_W_cell = Mem_W_cell + 4;
                    if(Param == LEFT_SPIN)  if(Mem_W_cell > N_MEM_RADIO_MIN) Mem_W_cell = Mem_W_cell - 4;
                    DiplayMemoryRadio_W_cellChange();
					break;
                 case LOAD: //     
                    if(Param == RIGHT_SPIN) if(Mem_R_cell < N_MEM_RADIO_MAX) Mem_R_cell = Mem_R_cell + 4;
                    if(Param == LEFT_SPIN)  if(Mem_R_cell > N_MEM_RADIO_MIN) Mem_R_cell = Mem_R_cell - 4;
                    f_change = TRUE;  
					break; 
               }                              
               break;     
        }
		sleep_count = 0;
        Param = 0;    
	 }	
	 
	 if(f_butM == TRUE)  //  
	 { 
        switch(Radio_Mode) 
        {
           //-----------  
           case RADIO:               
              if(f_butM_3c == FALSE) //  2 
		         Set_Regim();
              else                    // 2  
              {                    
                 menu_radio = SAVE;
				 DiplayMemoryRadio();
                 while(GetState(BUT_IN, BUT_M_Bit) == 0);	//   			 
                 Radio_Mode =  MENU_MEMORY;
				 nokia_cls();				 
              }
			  f_butM_3c = FALSE;
			  f_change = TRUE;
			  break;
           //----------    
           case MENU: 
		      switch(menu_option)
              {
			      case SAVE_O:  //    -       
				    APU_intMEM      = APU_int;
                    N_ViewMEM       = N_View;
	                ARU_intMEM      = ARU_int;
	                Sleep_intMEM    = Sleep_int;
					FindStepMEM     = FindStep;
                    FrcvWorkMEM     = FrcvWork;
                    Resiver_modeMEM = Resiver_mode;
					BRUST_intMEM    = BRUST_int;
                    Quarz_intMEM    = Quarz_int;
                    wMEM_Options();
					f_Memwrite = TRUE;
					break;
				  case EXIT_O: //    -   
				    Radio_Mode =  RADIO;
				    nokia_cls();
					break;
			  }
			  f_change = TRUE;
              break;
           //----------       
           case MENU_MEMORY:
              switch(menu_radio)
              {
                 case SAVE:     menu_radio = LOAD;      break; //   
                 case LOAD:     menu_radio = EXIT;      break; //   
                 case EXIT:     menu_radio = SAVE;      break; //                
              } 
			  DiplayMemoryRadio_ChangePosition();
              break;  
        }
		sleep_count = 0;		
        f_butM = FALSE; 
	 }
	 if(f_butS == TRUE)  //  
	 {      
        switch(Radio_Mode) 
        {
           //-----------  
           case RADIO:         
		      if(f_butS_3c == FALSE) //  2 
		      {
		         if(FindStep != STEPS_MAX) FindStep++;
		         else                       FindStep = 0;                               
              }
			  else                   // 2 
			  {
			     menu_option = APU;
				 DiplayMENURadio();
				 while(GetState(BUT_IN, BUT_S_Bit) == 0);	//   
                 Radio_Mode =  MENU;
                 nokia_cls(); 	
			  }
			  f_change = TRUE; 
			  f_butS_3c = FALSE;
              break;
           //----------    
           case MENU: 
		      switch(menu_option)
              { 
			     case APU:    menu_option = View;    break;//   SQL
			     case View:   menu_option = ARU;     break;//                       
                 case ARU:    menu_option = SLEEP;   break;//                         
                 case SLEEP:  menu_option = BRUST;   break;//   .
				 case BRUST:  menu_option = QUARZ;   break;//    				 
				 case QUARZ:  menu_option = SAVE_O;  break;//   
				 case SAVE_O: menu_option = EXIT_O;  break;//   
				 case EXIT_O: menu_option = APU;     break;//   
			  } 
			  //DiplayMENURadio_ChangePosition();
			  f_change = TRUE; 
              break;
           //----------       
           case MENU_MEMORY:
              switch(menu_radio)
              {
                 case SAVE:   //    -    
                    IndMEM          = Mem_W_cell;
                    FrcvWorkMEM     = FrcvWork;
                    Resiver_modeMEM = Resiver_mode;
                    wMEM_Freq();
					f_Memwrite = TRUE;
                    break;
                 case LOAD:  //    -    
                    {
                       if(rMEM_Freq())
					   {					   
					      FrcvWork     = FrcvWorkMEM;
                          Resiver_mode = Resiver_modeMEM;
					      Lc72131Set(); //       
                          KSH14xPLL2(); //   
					   }	  
                    }
                    break;                      
                 case EXIT:   //    -    
                    Radio_Mode = RADIO;
					nokia_cls();                   
                    break; 
              }    
			  f_change = TRUE; 
              break;  
		}  	
        sleep_count = 0;	
		f_butS = FALSE;  
	 }
	 if(f_change == TRUE)  //    
	 {
	    f_change = FALSE; 
		switch(Radio_Mode) 
        {
		   //----------  
		   case RADIO:       //   	      
			  DiplayFreq_Normal();		  
			  break;
		   //----------    
           case MENU:        //   
		       DiplayMENURadio();
              break;  
		   //----------       
           case MENU_MEMORY: //   
              DiplayMemoryRadio();
              break;  	  
		}
	 } 	
	 
	 if(f_state == TRUE)
	 {  
	    f_state = FALSE;
	    ReadBatState();      //      
		DiplayBatState();
		ReadLC72131State();  //      
	 }	
	 
     if(f_sleep == TRUE)      //  
	 {
	    OFF_Light();
		Go_To_Sleep();
		f_sleep = FALSE;
	 }
	 if(f_WakeUP == TRUE)    //  
     {
	    ON_Light();
	    Go_To_WakeUp();
		f_WakeUP = FALSE;
     } 	 
  }
	
  return 0;
}     
